package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;

	import flash.geom.Point;


	public class AI extends Player
	{
		public function AI(Jeu:Game,Joueur:int)
		{
			this.Jeu = Jeu;
			this.Terrain = Jeu.Terrain;
			this.Joueur=Joueur;
		}

		public function Jouer():void
		{
			this.TraceInfo="OK"+Taille;
			Tour_Termine=false;
			var Aretes_Ponderees:Array=this.getPonderedEdges();
			var Taille:int=Aretes_Ponderees[0].length;
			var BestEdges:int=-1;
			var BestEdgesCoeff:Number=-1;
			var BestNbOccurences:int=100;

			for(var i:int=0;i<Taille;i++)
			{
				if(BestEdgesCoeff<=Aretes_Ponderees[i][0] && BestNbOccurences>Aretes_Ponderees[i][1])
				{
					BestEdges=i;
					BestEdgesCoeff=Aretes_Ponderees[i][0];
				}
				if(Aretes_Ponderees[i][0]!=0)
					this.Terrain.All_Liens[i].AddFocus(5*Aretes_Ponderees[i][0])
			}

			JouerArete(this.Terrain.All_Liens[BestEdges]);
		}

		//Fonctions prives

		private function getPonderedEdges():Array
		{//Cette fonction renvoie la liste des artes tries par ordre d'importance...selon un pseudo-pathfinding.
			var All_Possible_Path:Array=new Array();

			function PathFind(Node:Noeud,Path:ArrayPlus):void
			{
				//Si le noeud examin est le noeud final, on a un nouveau chemin : l'enregistrer en mmoire.
				if(Node==Terrain.EndNode)
					All_Possible_Path.push(Path);

// 				Puis on regarde chaque arete du noeud et on teste rcursivement.
				for each(var Arete:Arc in Node.Liens)
				{
					if(!Path.Contains(Arete))
					{
						var CopiePath:ArrayPlus=Path.Clone();
						CopiePath.push(Arete);
						if(Arete.Extremites[0]==Node)
							PathFind(Arete.Extremites[1],CopiePath)
						else
							PathFind(Arete.Extremites[0],CopiePath)
					}
				}
			}
			PathFind(this.Terrain.StartNode,new ArrayPlus());

			//A ce point, le tableau All_Possible_Path est plein et contient l'ensemble des chemins que l'on peut emprunter pour se rendre du dpart  l'arrive.

			function SizeOf(Item:ArrayPlus):int
			{//Renvoie le nombre minimal d'artes  allumer pour terminer le chemin :
				var Jouees:int=0;
				for each(var Arete:Arc in Item)
				{
					if(Arete.PlayedByShort==true)
						Jouees++;
				}
				return (Item.length-Jouees);
			}

			//On initialise la rponse :
			var Poids:Array=new Array();
			var Taille:int=this.Terrain.All_Liens.length;
			for(var i:int=0;i<Taille;i++)
				Poids[i]=new Array(0,0);

			//On va maintenant compter combien de fois chaque arete est prsente :
			for each(var Path:ArrayPlus in All_Possible_Path)
			{
				for each(var Arete:Arc in Path)
				{
					if(Arete.PlayedByShort==false)
					{
						Poids[Arete.ID][0] +=1/SizeOf(Path);
						Poids[Arete.ID][1]++;
					}
				}
			}
			return Poids;
		}
	}
}